<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="sqf-implementing-framework">
  <title>Integrating SQF in a Framework and Sharing Them</title>
  <prolog>
    <metadata>
      <keywords>
        <indexterm>Schematron Quick Fixes<indexterm>Integrating in a
          framework</indexterm></indexterm>
        <indexterm>Schematron Quick Fixes<indexterm>Sharing</indexterm></indexterm>
        <indexterm>SQF<indexterm>Integrating in a framework</indexterm></indexterm>
        <indexterm>SQF<indexterm>Sharing</indexterm></indexterm>
        <indexterm>Integrate Schematron Quick Fixes in a framework</indexterm>
        <indexterm>Sharing Schematron Quick Fixes</indexterm>
      </keywords>
    </metadata>
  </prolog>
  <body>
    <p id="p_snh_cgk_54b">You can use Schematron <xref keyref="glossentry_quick-fix"><term>Quick Fixes</term></xref> to
      assist your content authors by imposing rules for an entire <xref
        keyref="glossentry_framework"><term>framework</term></xref> (document type) and offering
      fixes when a rule violation is detected.</p>
    <p id="p_tnh_cgk_54b">For example, if you are using DITA, you may want your contributors to avoid inserting a
      figure (<xmlelement>fig</xmlelement> element) inside a paragraph (<xmlelement>p</xmlelement>
      element) that contains other content since it may result in undesirable placement or spacing
      in the output. The Schematron rule and its <term>Quick Fix</term> for this particular use-case
      could look like this:</p>
    <p id="p_unh_cgk_54b">
      <codeblock  id="codeblock_vnh_cgk_54b">&lt;schema xmlns="http://purl.oclc.org/dsdl/schematron"
    xmlns:sqf="http://www.schematron-quickfix.com/validator/process"
 queryBinding="xslt2">
   &lt;pattern id="check.figure.location">
     &lt;rule context="p/fig">
         &lt;report test="true()" role="warn" sqf:fix="moveAfter">
         A figure inside a paragraph doesn't transform well into PDF. &lt;/report>
         &lt;sqf:fix id="moveAfter">
             &lt;sqf:description>
                 &lt;sqf:title>Move after the paragraph.&lt;/sqf:title>
             &lt;/sqf:description>
             &lt;let name="figToMove" value="."/>
             &lt;sqf:add match="parent::p" select="$figToMove" position="after"/>
             &lt;sqf:delete match="."/>
         &lt;/sqf:fix>
     &lt;/rule>
   &lt;/pattern>
&lt;/schema></codeblock>
    </p>
    <p id="p_wnh_cgk_54b">The result of this example would be that the user will see a warning if they insert a
        <xmlelement>fig</xmlelement> element inside a <xmlelement>p</xmlelement> element and they
      are presented with the option of selecting the <term>Quick Fix</term> that would move the
      figure outside the paragraph.</p>
    <section id="how_to_integrate_sqf_in_a_framework">
      <title>How to Integrate SQF in a Framework</title>
      <p id="p_xnh_cgk_54b">To integrate a Schematron <term>Quick Fix</term> in a <xref keyref="glossentry_framework"
            ><term>framework</term></xref>, follow these steps:<ol id="ol_ynh_cgk_54b">
          <li conkeyref="reusables-editing-documents/step1" id="li_znh_cgk_54b"/>
          <li conkeyref="reusables-editing-documents/Step2" id="li_a4h_cgk_54b"/>
          <li id="li_b4h_cgk_54b"><xref href="customizing-sqf.dita#customizing-sqf">Define the Schematron <term>Quick
                Fix</term> for a rule</xref> in an existing or new Schematron file and save it in
            the folder you created in step 2.</li>
          <li conkeyref="reusables-editing-documents/step4" id="li_c4h_cgk_54b"/>
          <li conkeyref="reusables-editing-documents/step5" id="li_d4h_cgk_54b"/>
          <li conkeyref="reusables-editing-documents/step6" id="li_e4h_cgk_54b"/>
          <li id="step8">Make whatever changes you desire to the extension, then go to the
              <b>Validation</b> tab, edit the default validation scenario (select the scenario and
            click the <uicontrol><image href="../img/Wrench16.png"/>Edit</uicontrol> button), and
            add an extra validation unit to it (one that uses your custom Schematron file that
            includes the SQF).<ph product="author editor authorEclipse editorEclipse"> For more
              details about editing validation scenarios, see <xref
                href="../topics/dg-validation-scenarios.dita"/>.</ph></li>
          <li conkeyref="reusables-editing-documents/step9" id="li_f4h_cgk_54b"/>
          <li id="li_g4h_cgk_54b">Add a reference to the Schematron file that includes the SQF in your
              <term>framework</term> by following the procedure in <xref
              href="associate-schema-framework-validation.dita#associate-schema-framework-validation"
            />.</li>
          <li id="li_h4h_cgk_54b">Open a document in your <term>framework</term> and test the new rule and <term>Quick
              Fix</term>.</li>
          <li conkeyref="reusables-editing-documents/step12" id="li_i4h_cgk_54b"/>
        </ol></p>
    </section>
    <section id="sharing_schematron_quick_fixes">
      <title>Sharing Schematron Quick Fixes</title>
      <p id="p_j4h_cgk_54b">To share Schematron Quick Fixes with other members of your team, you simply need to share
        the framework where you integrated the SQF.<ph product="editor editorEclipse"> There are
          several methods for sharing frameworks and you can find details here: <xref
            href="author-document-type-extension-sharing.dita"/>.</ph></p>
    </section>
  </body>
  <related-links>
    <linklist>
      <title>Related Information:</title>
      <link href="customizing-sqf.dita#customizing-sqf"/>
      <link href="sqf-operations.dita#sqf-operations"/>
      <link href="associate-schema-framework-validation.dita#associate-schema-framework-validation"/>
      <link href="author-document-type-extension-sharing.dita" product="editor editorEclipse"/>
    </linklist>
  </related-links>
</topic>
